#include <windows.h>
#include "finder.h"
#include "resource.h"
#include <cstring>
#include <vector>

char code[65535] = "HWND FindWindowS(char* class_name, char* window_text) \r\n\
{ \r\n\
    HWND hwnd = FindWindowEx(NULL, NULL, NULL, NULL); \r\n\
    while ( hwnd != NULL ) \r\n\
    { \r\n\
        char h_class_name[1024], h_window_text[1024]; \r\n\
        GetClassName(hwnd, h_class_name, 1024); \r\n\
        GetWindowText(hwnd, h_window_text, 1024); \r\n\
        bool class_match, window_match; \r\n\
        class_match = (class_name==NULL)?true:(strstr(h_class_name, class_name)!=NULL); \r\n\
        window_match = (window_text==NULL)?true:(strstr(h_window_text, window_text)!=NULL); \r\n\
        if ( class_match && window_match ) \r\n\
            return hwnd; \r\n\
        hwnd = FindWindowEx(NULL, hwnd, NULL, NULL); \r\n\
    } \r\n\
    return NULL; \r\n\
} \r\n\
 \r\n\
HWND IterateHWNDs(HWND base, int num, int* scan) \r\n\
{ \r\n\
    HWND child; \r\n\
    for (int i=0; i<num; i++) \r\n\
    { \r\n\
        child = FindWindowEx(base, NULL, NULL, NULL); \r\n\
        for (int j=0; j<scan[i]; j++) \r\n\
        { \r\n\
            child = FindWindowEx(base, child, NULL, NULL); \r\n\
        } \r\n\
        base = child; \r\n\
    } \r\n\
    return base; \r\n\
}";

void generate_code(HWND dialog_hwnd, HWND hwnd, char* func_name)
{
    char buffer[65535] = "";
    char temp[1024] = "";

    // Iterate the parent tree.
	std::vector<HWND> tree;
    tree.push_back(hwnd);
    HWND parent = GetAncestor(hwnd, GA_PARENT);
    while ( parent != NULL )
    {
        tree.push_back(parent);
        parent = GetAncestor(parent, GA_PARENT);
    }

    // Find number of times to skip.
	std::vector<int> skip;
    for (int i=0; i<tree.size()-2; i++)
    {
        int skip_num = 0;
        HWND child = FindWindowEx(tree[i+1], NULL, NULL, NULL);
        if (child == NULL)
        {
            MessageBoxA(NULL, "ERROR: Child not found in parent list!", "HWND Hunter", NULL);
            exit(1);
        }
        while (child != tree[i])
        {
            child = FindWindowEx(tree[i+1], child, NULL, NULL);
            skip_num += 1;
            if (child == NULL)
            {
                MessageBoxA(NULL, "ERROR: Child not found in parent list!", "HWND Hunter", NULL);
                exit(1);
            }
        }
        skip.push_back(skip_num);
    }

    // Find root window information.
    char class_name[1024], window_text[1024], class_type[1024];
	GetClassNameA(hwnd, class_type, sizeof (class_type) - 1);
    GetClassNameA(tree[tree.size()-2], class_name, 1024);
    GetWindowTextA(tree[tree.size()-2], window_text, 1024);

    sprintf(buffer, "HWND FindHWND_%s()\r\n{\r\n   // class type: %s \r\n   HWND base = FindWindowS(\"%s\", \"%s\");\r\n   if ( base == NULL ) return NULL;\r\n   int scan[%d] = {", func_name, class_type, class_name, window_text, skip.size());
    for (int i=skip.size()-1; i>0; i--)
    {
        sprintf(temp, "%d, ", skip[i]);
        strcat(buffer, temp);
    }
    sprintf(temp, "%d};\r\n   return IterateHWNDs(base, %d, scan);\r\n}\r\n", skip[0], skip.size());
    strcat(buffer, temp);
    strcat(buffer, "\r\n");
    strcat(buffer, code);
	strcpy(code, buffer);
}

BOOL CALLBACK MainDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
	char func_name[1024];

    switch(Message)
    {
        case WM_INITDIALOG:
			SetDlgItemTextA(hwnd, IDC_CODE, code);
	        return TRUE;

		case WM_CLOSE:
			EndDialog(hwnd, NULL);
			break;

        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
				case IDC_ADD:
					HWND target_hwnd;
					char class_name[256];
					CloseWindow(hwnd);
					target_hwnd = Finder_FindHWND();
					OpenIcon(hwnd);
					GetDlgItemTextA(hwnd, IDC_FUNCNAME, func_name, sizeof(func_name)-1);
					if ( target_hwnd != 0 )
						generate_code(hwnd, target_hwnd, func_name);
					SetDlgItemTextA(hwnd, IDC_CODE, code);
					break;
            }
        break;

        default:
            return FALSE;
    }
    return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_MAIN), NULL, MainDlgProc);
    return 0;
}